﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Audio;

public class EnemyController : MonoBehaviour , IHealth {
    
    public float speed;

    public float EnemyHitPoints = 1;
    public float EnemyHitPointMax = 1;

    public float EnemyAttackDelay = 2;
    public GameObject EnemyAttack;
    public int EnemyAttackDamage = 1;
    public bool readyToAttack = true;

    public GameObject EnemyAttackLocation;


    //audio
    public AudioClip[] clips;

   
    private void Awake()
    {
        EnemyHitPoints = EnemyHitPointMax;
    }
    void Update()
    {
        
        transform.position += transform.right * speed * Time.deltaTime;
    }

    
    private void OnTriggerStay2D(Collider2D collision)
    {
        
        if (readyToAttack)
        {
            
            if (collision.gameObject.CompareTag("Player"))
            {
                print("enemy colliding with player");
                readyToAttack = false;
                StartCoroutine(ResetAttackDelay());
                IHealth mybox = collision.GetComponent<IHealth>();
                if (mybox != null)
                {
                    mybox.TakeDamage(EnemyAttackDamage);
                    print("EnemyDealing Damage");
                }
            }
        }
        
    }

    IEnumerator ResetAttackDelay()
    {
        yield return new WaitForSeconds(EnemyAttackDelay);
        readyToAttack = true;


        yield return null;
    }

    public void TakeDamage(float amount)
    {
        //make flash
        //Healthbar stuff
        //hit effect
        //hit sound
        EnemyHitPoints -= amount;
        if(EnemyHitPoints <= 0)
        {
            Dead();
        }
    }
    public void Dead()
    {
        //death poof
        Destroy(gameObject);
        playRandomSound();
    }

    public void playRandomSound()
    {
        
            GameObject sound = new GameObject();
            sound.transform.position = transform.position;
            int randomClip = Random.Range(0, clips.Length);
            AudioSource audioSource = sound.AddComponent<AudioSource>();
            audioSource.clip = clips[randomClip];
            audioSource.Play();
            Destroy(sound, clips[randomClip].length);
        
    }
}
