﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;
public class HeroController : MonoBehaviour , IHealth {
 
    
    //player Stats
    public int Hitpoints = 5;
    public int HitpointsMax = 5;
    public float HeroAttackDelay = 1;
    private bool ReadytoAttack = true;
    public int HeroAttackDamage;
    public int Experience;
    public int HeroLevel;
    public GameObject HeroAttack;
    public GameObject AttackLocation;

    public Image healthbar;
    public Image ExpBar;
    public Image ProgressBar;

    public float endtime = 30;
    public float timeCounter;

    //exp values
    public int Enemy1Worth = 1;
    public int Enemy2Worth = 10;
    public int Enemy3Worth = 20;

    public float NextLevelUp = 10;

    public GameObject Buttons;
    public GameObject Guard;
    public GameObject spawnlocation;



    //audio
    public AudioClip[] clips;
    
    //backgrounds

    public GameObject EntranceIMG;
    public GameObject DiningRoomIMG;
    public GameObject ThroneRoomIMG;


    public void Awake()
    {
        Experience = 0;
        HeroLevel = 1;
        Hitpoints = HitpointsMax;
    }


    //attacks enemies and awards exp
    private void OnTriggerStay2D(Collider2D collision)
    {
        if (ReadytoAttack == true)
        {
            if (collision.gameObject.CompareTag("Enemy1") || collision.gameObject.CompareTag("Enemy2")
                || collision.gameObject.CompareTag("Enemy3"))
            {
                ReadytoAttack = false;


                //move these to own score keeper script
                if (collision.gameObject.CompareTag("Enemy1"))
                {
                    GainExperience(Enemy1Worth);
                    
                    
                }
                if (collision.gameObject.CompareTag("Enemy2"))
                {
                    GainExperience(Enemy2Worth);

                }
                if (collision.gameObject.CompareTag("Enemy3"))
                {
                    GainExperience(Enemy3Worth);

                }


                //add sound here
                playRandomSound();
                StartCoroutine(resetReadytoAttack());
                Instantiate(HeroAttack, AttackLocation.transform.position, AttackLocation.transform.rotation);
                IHealth mybox = collision.GetComponent<IHealth>();
                if (mybox != null)
                {
                    mybox.TakeDamage(HeroAttackDamage);
                }
            }
        }
    }
   IEnumerator resetReadytoAttack()
    {
        yield return new WaitForSeconds(HeroAttackDelay);
        ReadytoAttack = true;

        yield return null;
    }
   
    public void GainExperience(int expAmount)
    {
        Experience += expAmount;
        ExpBar.fillAmount = (float)Experience / (float)NextLevelUp;
        if (Experience >= NextLevelUp)
        {
            LevelUp();
            backgroundChange();
        }
    }
    public void LevelUp()
    {
        //level up sound here
        HeroLevel++;
        NextLevelUp += NextLevelUp *10;
        HitpointsMax += 10;
        Hitpoints = HitpointsMax;
        healthbar.fillAmount = ((float)Hitpoints / (float)HitpointsMax);
        HeroAttackDamage += 1;
        
    }
 

    public void TakeDamage(float amount)
    {
        //make flash              
        //hit effect
        //hit sound
        Hitpoints -= (int)amount;
        healthbar.fillAmount = ((float)Hitpoints / (float)HitpointsMax);
        if (Hitpoints <= 0)
        {
            Dead();
        }
    }
    public void Dead()
    {
        //death poof
        Destroy(gameObject);
    }

    public void Update()
    {
        
        // timer/progress bar

        
        timeCounter++;
        ProgressBar.fillAmount = timeCounter / endtime;

        if (timeCounter == endtime)
        {
            Buttons.SetActive(false);
            Instantiate(Guard, spawnlocation.transform.position, spawnlocation.transform.rotation);
        }    //you lose txt here

    }
    public void playRandomSound()
    {

        GameObject sound = new GameObject();
        sound.transform.position = transform.position;
        int randomClip = Random.Range(0, clips.Length);
        AudioSource audioSource = sound.AddComponent<AudioSource>();
        audioSource.clip = clips[randomClip];
        audioSource.Play();
        Destroy(sound, clips[randomClip].length);

    }

    public void backgroundChange()
    {
        if (HeroLevel == 1)
        {
            EntranceIMG.SetActive(true);
            DiningRoomIMG.SetActive(false);
            ThroneRoomIMG.SetActive(false);

        }
        if (HeroLevel == 2)
        {
            EntranceIMG.SetActive(false);
            DiningRoomIMG.SetActive(true);
            ThroneRoomIMG.SetActive(false);

        }
        if (HeroLevel == 3)
        {
            EntranceIMG.SetActive(false);
            DiningRoomIMG.SetActive(false);
            ThroneRoomIMG.SetActive(true);

        }
    }
}
