﻿using UnityEngine;
using System.Collections;

public class SeekerBullet : MonoBehaviour
{
    public GameObject Target;
    public float Speed = 1;

    //this is the custom rotation speed setting. It works wonderfully.
    public float Rotation = 200;
    public float Damage = 3;

    Rigidbody2D rb;

    void Start()
    {
       
        Target = GameObject.FindGameObjectWithTag("Player");
        rb = GetComponent<Rigidbody2D>();
    }

    void Update()
    {
        if (Target == null)
        {
            Destroy(gameObject);
        }
        Vector2 PointToTarget = (Vector2)transform.position - (Vector2)Target.transform.position;

        PointToTarget.Normalize();

        float value = Vector3.Cross(PointToTarget, transform.right).z;

        if (value > 0)
        {
            rb.angularVelocity = Rotation;
        }
        else if (value < 0)
        {
            rb.angularVelocity = -Rotation;
        }
        else
            Rotation = 0;

        rb.angularVelocity = Rotation * value;

        rb.velocity = transform.right * Speed;
    }
}
